---
prev: false
---

![Teacher Hardhat](/hardhat-tutorial.svg)

# Hardhat's tutorial for beginners

Welcome to our beginners guide to Ethereum contracts and dApp development. This tutorial aims to quickly get you set up to build something from scratch.

To orchestrate this process we're going to use Hardhat, a development environment that facilitates building on Ethereum. It helps developers manage and automate the recurring tasks that are inherent to the process of building smart contracts and dApps, and it allows you to easily introduce more functionality around this workflow. This means compiling and testing at the very core.

Hardhat also comes built-in with Hardhat Network, a local Ethereum network designed for development. It allows you to deploy your contracts, run your tests and debug your code.

In this tutorial we'll guide you through:

- Setting up your Node.js environment for Ethereum development
- Creating and configuring a Hardhat project
- The basics of a Solidity smart contract that implements a token
- Writing automated tests for your contract using Hardhat
- Debugging Solidity with `console.log()` using Hardhat Network
- Deploying your contract to Hardhat Network and Ethereum testnets

To follow this tutorial you should be able to:

- Write code in [JavaScript](https://developer.mozilla.org/en-US/docs/Learn/Getting_started_with_the_web/JavaScript_basics)
- Operate a [terminal](https://en.wikipedia.org/wiki/Terminal_emulator)
- Use [git](https://git-scm.com/doc)
- Understand the basics of how [smart contracts](https://ethereum.org/learn/#smart-contracts) work
- Set up a [Coinbase](https://www.coinbase.com/wallet) or [Metamask](https://metamask.io/) wallet

If you can't do any of the above, follow the links and take some time to learn the basics.
